package csvparser

import (
	"fmt"
	"testing"
)

func TestCorrectLines(t *testing.T) {
	var csvParser CsvParser
	csvParser.Initialize(" ", []string{"\"\"", "[]"}, "firstname lastname complete_name")
	line := ""
	fmt.Println("parsing:", line)
	event, err := csvParser.Parse(line)
	if err != nil {
		t.Fatalf("Parsing of empty line failed %v %v", err, event)
	}
	fmt.Println("event is", event)

	line = "John"
	fmt.Println("parsing:", line)
	event, err = csvParser.Parse(line)
	if err != nil {
		t.Fatalf("Parsing of empty line failed %v %v", err, event)
	}
	fmt.Println("event is", event)

	line = "John Doe"
	fmt.Println("parsing:", line)
	event, err = csvParser.Parse(line)
	if err != nil {
		t.Fatalf("Parsing of empty line failed %v %v", err, event)
	}
	fmt.Println("event is", event)

	line = "John \"John Doe\" Doe"
	fmt.Println("parsing:", line)
	event, err = csvParser.Parse(line)
	if err != nil {
		t.Fatalf("Parsing of empty line failed %v %v", err, event)
	}
	fmt.Println("event is", event)

	line = "John Doe \"John Doe\""
	fmt.Println("parsing:", line)
	event, err = csvParser.Parse(line)
	if err != nil {
		t.Fatalf("Parsing of empty line failed %v %v", err, event)
	}
	fmt.Println("event is", event)

	line = "John Doe \"John Doe\"\\\\"
	fmt.Println("parsing:", line)
	event, err = csvParser.Parse(line)
	if err != nil {
		t.Fatalf("Parsing of empty line failed %v %v", err, event)
	}
	fmt.Println("event is", event)

	line = "John Doe I don't know him"
	fmt.Println("parsing:", line)
	event, err = csvParser.Parse(line)
	if err != nil {
		t.Fatalf("Parsing of empty line failed %v %v", err, event)
	}
	fmt.Println("event is", event)
}
